#!/usr/bin/env python

import commands
import pygtk
import sys
import gconf
pygtk.require('2.0')
import gobject
import gnomeapplet
import gtk,os, Image, ImageDraw, ImageFont
import subprocess, gnomevfs
num = 0
button = gtk.Button()
display = 0
client = gconf.client_get_default ()
icontheme = client.get_string("/desktop/gnome/interface/icon_theme")
utente = os.environ.get( "USERNAME" )

icone = ["/usr/share/icons/"+icontheme+"/32x32/devices/drive-harddisk.png",
"/usr/share/icons/"+icontheme+"/32x32/devices/gnome-dev-removable-usb.png",
"/usr/share/icons/"+icontheme+"/32x32/devices/gnome-dev-dvd.png",
"/usr/share/icons/"+icontheme+"/32x32/devices/drive-harddisk.png",
"/usr/share/icons/"+icontheme+"/32x32/places/user-home.png",
"/usr/share/icons/"+icontheme+"/32x32/actions/gtk-open.png",
"/usr/share/icons/"+icontheme+"/32x32/actions/go-up.png",
"/usr/share/icons/"+icontheme+"/16x16/places/folder.png"]

for item in icone:
	if os.path.exists(item)==False:
		#print item
		icontheme='gnome'

def on_select(icon_view,model=None):
			selected = icon_view.get_selected_items()
			if len(selected)==0: return
			i = selected[0][0]
			dir = model[i][1]
			
			if model[i][2]=="dir":
			##i = selected[0][0][0]
				print dir
				mostradir (dir)
			if (model[i][2]=="apri"):
				subprocess.Popen('nautilus "'+dir+'"',shell=True)

def esci(finestra, iid):
	if finestra.is_active()==False: finestra.destroy()
	return True
def mostradir(dir):
			global icontheme
			win = gtk.Window(gtk.WINDOW_TOPLEVEL)
			win.set_position(gtk.WIN_POS_MOUSE)
			win.set_title(dir)
			win.set_default_size(350,250)
			gobject.timeout_add(4000,esci,win,None)
			
			#win.resizable(False)
			win.set_opacity(0.8)
			model = gtk.ListStore(str,str,str,gtk.gdk.Pixbuf)
			scroll = gtk.ScrolledWindow() 
			fol = rildir(dir)
			pixbuf = gtk.gdk.pixbuf_new_from_file("/usr/share/icons/"+icontheme+"/32x32/actions/gtk-open.png")
			model.append(["Nautilus",dir,'apri',pixbuf])
			pixbuf = gtk.gdk.pixbuf_new_from_file("/usr/share/icons/"+icontheme+"/32x32/actions/go-up.png")
			
			#CDIR
			ndir = dir.split("/")
			cdir = ""
			##print len(ndir)
			for z in range (1,len(ndir)-1):
				cdir = cdir+"/"+ndir[z]
			##
			if dir!="/home":
				model.append(["",cdir,'dir',pixbuf])
			for nome in fol:
				if nome[0]!=".":
					if os.path.isdir(dir+'/'+nome):
						pixbuf = gtk.gdk.pixbuf_new_from_file("/usr/share/icons/"+icontheme+"/32x32/places/folder.png")
						if ((dir!="/") and (len(nome)>0)): model.append([nome,dir+'/'+nome,'dir',pixbuf])
						if ((dir=="/") and (len(nome)>0)): model.append([nome,dir+nome,'dir',pixbuf])
					if os.path.isfile(dir+'/'+nome):
						ext = os.path.splitext(dir+'/'+nome)[-1];
						est = ext[1:]
						if os.path.isfile("/usr/share/icons/"+icontheme+"/32x32/mimetypes/"+est+".png"):
							pixbuf = gtk.gdk.pixbuf_new_from_file("/usr/share/icons/"+icontheme+"/32x32/mimetypes/"+est+".png")
						elif os.path.isfile("/usr/share/icons/"+icontheme+"/32x32/mimetypes/gtk-file.png"):
							pixbuf = gtk.gdk.pixbuf_new_from_file("/usr/share/icons/"+icontheme+"/32x32/mimetypes/gtk-file.png")
						else:
							pixbuf = gtk.gdk.pixbuf_new_from_file("/usr/share/icons/gnome/32x32/mimetypes/gtk-file.png")
							
						model.append([nome,dir+'/'+nome,'file',pixbuf])
			iv = gtk.IconView(model)
			iv.set_text_column(0)
			#iv.set_text_column(1)
			#iv.set_text_column(2)
			iv.set_pixbuf_column(3)
			iv.set_orientation(gtk.ORIENTATION_VERTICAL)
			iv.set_selection_mode(gtk.SELECTION_SINGLE)
			iv.connect('selection-changed',on_select,model)
			##iv.connect('item-activated',self.avvianaut,model)
			iv.set_orientation(gtk.ORIENTATION_VERTICAL)
			iv.set_selection_mode(gtk.SELECTION_SINGLE)
			iv.set_margin(0)
			iv.set_row_spacing(0)
			iv.set_item_width(90)
			iv.set_column_spacing(0)
			iv.set_columns(3)
			#iv.set_size_request(72,-1)
			scroll.add(iv)
			win.add(scroll)
			win.show_all()
			
			#win.connect('destroy',gtk.main_quit())
			#win.connect('delete-event',gtk.main_quit())
		
		

def case_insensitive_cmp(a, b):
	return cmp(a.upper(), b.upper())

def rildir(dir):
			part = []
			path=dir
			part = os.listdir(path)
			part.sort(case_insensitive_cmp)
			return part

def listdir(button,loc):
			#lista = []
			#lista = rildir(loc)
			#for nome in lista:
			#	print nome
			mostradir(loc)
			
def rilpart():
			part = []
			vol_monitor = gnomevfs.VolumeMonitor()
			volume = gnomevfs.Volume()
			for volume in vol_monitor.get_mounted_volumes():
			  if volume.is_mounted():
				  if (volume.get_device_path().find("/dev")!=-1):
								nome = volume.get_display_name()
								if nome.find("/ ")!=-1: nome="Lin"
								if nome.find("GB")!=-1: nome=volume.get_device_path()[5:];
								#print volume.get_filesystem_type()
								dev = volume.get_device_path()
								path = volume.get_activation_uri().replace('file:///','/')
								part.append(path+"#"+nome+"#"+dev)
			return part

def spaziolibero(part):
	disk = os.statvfs(part)
	capacity = disk.f_bsize * disk.f_blocks
	available = disk.f_bsize * disk.f_bavail
	used = disk.f_bsize * (disk.f_blocks - disk.f_bavail)
	free = (available/1024/1024)
	occ = (capacity/1024/1024)
	stt = []
	stt.append((free,occ))
	return stt

def apri(button,loc):
	print loc
	subprocess.Popen('nautilus '+loc,shell=True)
	return True

def ripeti(applet, iid):
	global utente, icontheme
	drive = ""
	drive = rilpart()
	hbox = gtk.HBox()
	for widget in hbox.get_children():
		hbox.remove(widget)
	for widget in applet.get_children():
		applet.remove(widget)
	#print str(len(drive))
	for tut in drive:
				(drv,lab,ico) = tut.split("#")
				stt = spaziolibero(drv)
				libero = str(stt[0][0])
				complessivo = str(stt[0][1])
				if ico.find("sda")!=-1:
					icofile="/usr/share/icons/"+icontheme+"/32x32/devices/drive-harddisk.png"
				if ico.find("sdb")!=-1:
					icofile="/usr/share/icons/"+icontheme+"/32x32/devices/gnome-dev-removable-usb.png"
				if ico.find("sr")!=-1:
					icofile="/usr/share/icons/"+icontheme+"/32x32/devices/gnome-dev-dvd.png"
				if ((ico.find("sda")==-1) and (ico.find("sdb")==-1) and (ico.find("sr")==-1)):
					icofile="/usr/share/icons/"+icontheme+"/32x32/devices/drive-harddisk.png"
				im = Image.open(icofile)

				draw = ImageDraw.Draw(im)
				draw.rectangle ([(0,25),(32,32)],fill="#FFFFFF")
				l = ((stt[0][1]-stt[0][0])*32)/stt[0][1]
				draw.rectangle ([(0,25),(l,32)],fill="#FF0000")
				#x : 32 =  free : tot
				#draw.line((0, 0) + im.size, fill=128)
				#draw.line((0, im.size[1], im.size[0], 0), fill=128)
				
				####lab = drv.replace("/media/","")
				####if lab == "/":
				####	lab = "Linux"
				
				# use a bitmap font
				#font = ImageFont.load("arial.pil")
				# use a truetype font
				font = ImageFont.truetype("/var/lib/defoma/gs.d/dirs/fonts/FreeSansBold.ttf", 9)
				draw.text([11-len(lab[:3]),9],lab[:3].lower(),fill="#000000",font=font)
				del draw 
				# write to stdout
				
				im.save("/tmp/temphd.png", "PNG")

				#pixbuf = gtk.gdk.pixbuf_new_from_file("/usr/share/icons/gnome/32x32/devices/drive-harddisk.png")
				button = gtk.Button()
				#button.set_relief(gtk.RELIEF_NONE)
				#button.set_label(drv)
				image = gtk.Image()
				image.set_from_file(("/tmp/temphd.png"))
				button.connect("clicked",apri,drv)
				button.connect("button_press_event", showMenu, applet)
				#######TOLTObutton.connect("enter",listdir,drv)
				button.set_image(image)
				button.set_tooltip_text(drv+"\n"+"Free Space: "+str(stt[0][0])+" Mb\nTotal Space:"+str(stt[0][1])+" Mb") 
				hbox.add(button)	
	button = gtk.Button()
	image = gtk.Image()
	image.set_from_file("/usr/share/icons/"+icontheme+"/32x32/places/user-home.png")
	button.set_image(image)
	button.connect("clicked",listdir,"/home/"+utente)
	button.connect("button_press_event",showMenu,applet)
	hbox.add(button)
	applet.add(hbox)
	applet.show_all()
	return True

	
def factory(applet, iid):
	ripeti(applet,None)
	gobject.timeout_add(8000,ripeti,applet,None)
	return True

def about(*arguments, **keywords):
	subprocess.Popen("zenity --info --title='About HDMONITOR 0.6' --text='@2009 Palumbo Roberto.\nE-Mail: palumborobertomail@gmail.com\nWebsite: ubuntuwin.altervista.org'",shell=True)
	
def create_menu(applet):
	propxml="""
			<popup name="button3">
			<menuitem name="bbb" verb="About" label="About"/>
			<menuitem name="bbb" verb="About" label="Aggiornamenti su: ubuntuwin.altervista.org"/>
			</popup>"""
	verbs = [("About", about)]
	applet.setup_menu(propxml, verbs, None)


def showMenu(widget, event, applet):
	if event.button == 3:
		widget.emit_stop_by_name("button_press_event")
		create_menu(applet)

def showAboutDialog(*arguments, **keywords):
        pass

if len(sys.argv) == 2:
        if sys.argv[1] == "run-in-window":
				mainWindow = gtk.Window(gtk.WINDOW_TOPLEVEL)
				mainWindow.set_title("HD MONITOR")
				mainWindow.connect("destroy", gtk.main_quit)
				applet = gnomeapplet.Applet()
				factory(applet, None)
				applet.reparent(mainWindow)
				mainWindow.show_all()
				gtk.main()
				sys.exit()

if __name__ == '__main__':
		print "Starting HdMonitor"
		gnomeapplet.bonobo_factory("OAFIID:HDMONITOR_Factory", gnomeapplet.Applet.__gtype__, "hdmonitor", "1.0", factory)
